#include "ft_nm.h"

int main(int ac, char **av) {
	char *path = ft_strdup("a.out");

	if (ac > 1) {
		free(path);
		path = ft_strdup(av[1]);
	}

	int fd = open(path, O_RDONLY);
	if (fd == -1) {
		ft_nm_error(path);
		free(path);
		exit (EXIT_FAILURE);
	}

	struct stat stat;
	if (fstat(fd, &stat) == -1) {
		ft_nm_error(path);
		free(path);
		exit (EXIT_FAILURE);
	}

	t_mapped_file mapped_file;

//	ft_printf("sds", "file size: ", stat.st_size, "\n");
	mapped_file.ptr = mmap(NULL, stat.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
	mapped_file.size = stat.st_size;
	if (mapped_file.ptr != MAP_FAILED) {
		void *ident_ptr = fetch(mapped_file, 0, EI_NIDENT);
		unsigned char ident[EI_NIDENT];
		if (!ident_ptr) {
			ft_printf("sss", "nm: ", path, ": file format not recognized\n");
			free(path);
			exit(EXIT_FAILURE);
		}
		ft_memcpy(ident, ident_ptr, EI_NIDENT);
		if (check_ident(ident) == FT_NM_FAILURE) {
			ft_printf("sss", "nm: ", path, ": file format not recognized\n");
			free(path);
			exit(EXIT_FAILURE);
		}
		if (ident[EI_CLASS] == ELFCLASS32) {
			if (nm32(mapped_file) == FT_NM_FAILURE) {
				ft_printf("sss", "nm: ", path, ": file format not recognized\n");
				free(path);
				exit(EXIT_FAILURE);
			}
		}
		else if (ident[EI_CLASS] == ELFCLASS64) {
			if (nm64(mapped_file) == FT_NM_FAILURE) {
				ft_printf("sss", "nm: ", path, ": file format not recognized\n");
				free(path);
				exit(EXIT_FAILURE);
			}
		}
	}
	free(path);
	return 0;
}

